function [V,lambda,X_mean]=computePCA_eigenvectors(X,d);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

[n,k]=size(X);
%}

if nargin<2
    d=[];
end

[V,lambda,X_mean]=computePCA_eigenvectors_aux_bak1(X,d);


% [V,lambda,X_mean]=computePCA_eigenvectors_aux(X,d);
% [V2,lambda2,X_mean2]=computePCA_eigenvectors_aux_bak1(X,d);
% 
% norm1(V-V2)
% norm1(lambda-lambda2)
% norm1(X_mean-X_mean2)


function [V,lambda,X_mean]=computePCA_eigenvectors_aux(X,d);
%TODO:can it be made to work?
is_d=nargin>=2 && ~isempty(d);
[n,k]=size(X);
X_mean=sum(X,1)/n;
X=bsxfun(@plus,X,-X_mean);
% X=X';
% [V,lambda,ignore] = svd(X,0);
[ignore,lambda,V] = svd(X,0);

lambda=diag(lambda);
[lambda,ind]=sort(lambda,'descend');
V=V(:,ind);
if is_d
    V=V(:,1:d);
    lambda=lambda(1:d);
end

function [V,lambda,X_mean]=computePCA_eigenvectors_aux_bak1(X,d);
[S,X_mean]=computeCovariance(X);
is_d=nargin>=2 && ~isempty(d);

if is_d && size(S,1)>5 %far small dimensions, use eig    
    options=pca_funs.compute_options(size(S,1),d);
    S=double(S);
%     result = eigs_optimized(S,[],d,options);

    funs=eigs_funs;
    result=funs.eigs_compatible_with_eigs_optimized(S,[],d,options);

    V=result.X;
    lambda=result.lambda;
%     [V,lambda]=eigs(S);
%     lambda=diag(lambda);
else
    [V,lambda]=eig(S);
    lambda=diag(lambda);
end
[lambda,ind]=sort(lambda,'descend');
V=V(:,ind);
% lambda=lambda(end:-1:1);
% V=V(:,end:-1:1);

if is_d
    V=V(:,1:d);
    lambda=lambda(1:d);
end
