function result=compute_labels_from_bags(F,labels_bag,W,options0);
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE


options=[];
% options.is_balance=1;
options.is_balance=0;
% options.is_naive=1;
options.is_normalize_F=1;

if nargin<3
    W=[];
end
if nargin>=4
    options=getOptions(options,options0);
end

[n,d]=size(F);
[n1,k]=size(labels_bag);
assert(n==n1);

bags=compute_bags_from_labels_bag_2(labels_bag,W,options);
nbLabels=size(labels_bag,2);

%normalize features (esp important if adding a constant term apparently)
if options.is_normalize_F
    [F2,a,b]=normalizeFeatures(F);
else
    F2=F;
    a=[];
    b=[];
end

result=minimize_bag_loss_LP(bags,F2,nbLabels);
result.fun_scores0=result.fun_scores;

result.a=a';
result.b=b';
result.fun_scores=@compute_scores;
scores=result.fun_scores(F,result);
result.scores=scores;
result.labels=compute_max_scores_from_bags(scores,labels_bag);
[ignore,result.labels2]=max(scores,[],2);



0;

function scores=compute_scores(F,result);
if ~isempty(result.a)
    F=bsxfun(@plus,bsxfun(@times,F,result.a),result.b);
end
scores=result.fun_scores0(F,result);

