function labels=compute_max_scores_from_bags(scores,labels_bags);
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

labels=compute_max_scores_from_bags_max(scores,labels_bags);
% labels=compute_max_scores_from_bags_proportion(scores,labels_bags);
% labels=compute_max_scores_from_bags_proportion_matching(scores,labels_bags);

function labels=compute_max_scores_from_bags_max(scores,labels_bags);
scores(~labels_bags)=-Inf;
[ignore,labels]=max(scores,[],2);

function labels=compute_max_scores_from_bags_proportion(scores,labels_bags);
[n,k]=size(labels_bags);
L=compute_L(labels_bags);
scores(~labels_bags)=-Inf;

[ignore,ind]=sort(scores,2,'descend');
ind=ind';

isValid=true(k,1);
L2=zeros(k,1);
labels=zeros(n,1);
for i=1:n
    indi=ind(:,i);
    indi=indi(isValid(indi));
    indi=indi(1);
    L2(indi)=L2(indi)+1;
    if L2(indi)>L(indi)
        isValid(indi)=0;
    end        
    labels(i)=indi;
end

function L=compute_L(labels_bags);
[n,k]=size(labels_bags);
L=sum(labels_bags,1);
L=L/sum(L)*n;
L=round(L);
[ignore,ind]=max(L);
L(ind)=L(ind)+n-sum(L);

%{
function labels=compute_max_scores_from_bags_proportion_matching(scores,labels_bags);
[n,k]=size(labels_bags);
L=compute_L(labels_bags);
scores(~labels_bags)=-Inf;

for i=k:-1:1
    res(i).X=repmat(scores(:,i),1,L(i));
    res(i).E=repmat(labels_bags(:,i),1,L(i));
end
X=cat(2,res.X);
E=cat(2,res.E);
classes=indexes2classes(lengths2indexes(L));

Xd=computeDiscreteCorrespondancesGreedy(X,E);
[ignore,labels1]=max(Xd,[],2);
labels=classes(labels1);
%}

