classdef dependency_funs
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

        %{
funs=dependency_funs.dependency_funs();
filepaths=funs.depfun_plus_source('test_segment_frames_superpixels',0)
dispStrings2(filepaths)
% filepaths=funs.depfun('computeKFirstEigenvectors')
% filepaths=funs.dependencies_source_C(filepaths)
remote_dir='/home/tcour/programs/toolbox/benchmarkFrames_2';
for i=1:length(filepaths2)
command_scp(filepaths2{i},remote_dir,0,'file');
end
        %}
    methods(Static)
        function scratch();        
        files=dependency_funs.computeIncludeFiles(which('mex_paths_funs.cpp'));
%         res=ext_funs.compute_exts();
        
%         dependency_funs.ext_binary=res.ext_binary;%TODO:move out
%         dependency_funs.ext_source_C=res.ext_source_C;
%         dependency_funs.binary2source=@(filepaths)dependency_funs.binary2source(filepaths,funs);
%         dependency_funs.is_binary=@(filepaths)dependency_funs.compute_is_binary(filepaths,funs);
%         dependency_funs.depfun=@(filepaths)(depfun_dir(filepaths));
%         funs.dependencies_source_C=@(filepaths)(dependency_funs.compute_dependencies_source_C(filepaths,funs));
%         funs.depfun_plus_source=@(filepaths,is_inlcudeBinary)(dependency_funs.compute_depfun_plus_source(filepaths,is_inlcudeBinary,funs));
        % funs.send_files=@(filepaths)();
        end
        
        
        function filepaths=compute_depfun_plus_source(filepaths,is_inlcudeBinary,funs);
        filepaths=funs.depfun(filepaths);
        filepaths2=funs.dependencies_source_C(filepaths);
        filepaths=[filepaths;filepaths2];
        filepaths=unique(filepaths);
        if ~is_inlcudeBinary
            isValid=dependency_funs.compute_is_binary(filepaths,funs);
            filepaths(isValid)=[];
        end
        end
        
        
        function isValid=compute_is_binary(filepaths,funs);
        isValid=dependency_funs.is_exts(filepaths,funs.ext_binary);
        end
        
        function isValid=is_exts(filepaths,exts);
        n=length(filepaths);
        isValid=false(n,1);
        for i=1:n
            [ignore,ignore,ext]=fileparts(filepaths{i});
            isValid(i)=ismember(ext,exts);
        end
        end
        
        function filepaths_source_C=compute_dependencies_source_C(filepaths,funs);
        is_binary=dependency_funs.is_exts(filepaths,funs.ext_binary);
        is_source_C=dependency_funs.is_exts(filepaths,funs.ext_source_C);
        
        filepaths_source_C=filepaths(is_source_C);
        filepaths_source_C=[filepaths_source_C;dependency_funs.binary2source(filepaths(is_binary),funs)];
        filepaths_source_C=unique(filepaths_source_C);
        temp=computeIncludeDependencies(filepaths_source_C);
        filepaths_source_C2={temp(:).filepath};
        filepaths_source_C=[filepaths_source_C;filepaths_source_C2(:)];
        filepaths_source_C=unique(filepaths_source_C);
        end
        
        
        function filepaths=binary2source(filepaths,funs);
        isBinary=dependency_funs.compute_is_binary(filepaths,funs);
        assert(all(isBinary));
        for i=1:length(filepaths)
            filepath=filepaths{i};
            filepath2='';
            for j=1:length(funs.ext_source_C)
                filepath2=changeExt(filepath,funs.ext_source_C{j});
                if exist(filepath2,'file')
                    break;
                end
            end
            assert(~isempty(filepath2));
            filepaths{i}=filepath2;
        end
        end
        
        function files=computeIncludeFiles(filepath);
        [dirInput,ignore,ignore]=fileparts(filepath);
        sourceCode = textread(filepath,'%s','delimiter','\n','whitespace','');
        [match, first, last] = regexp(sourceCode, '#\s*include.*', 'match', 'start', 'end');
        % temp = strfind(sourceCode,'include');
        
        % files=emptyStruct({'fileInclude','path'});
        files=emptyStruct({'filepath'});
        nb=0;
        for i=1:length(match)
            if ~isempty(match{i})
                [isValidInclude,filename_i]=dependency_funs.computeIsValidInclude_syntax(sourceCode{i},match{i},first{i},last{i});
                %         if ~isfile(filename_i)
                if ~exist(filename_i,'file')
                    isValidInclude=false;
                end
                
                filepathi=fullfile(dirInput,filename_i);
                if ~isfile(filepathi)
                    filepathi=fullfile(getPaths('includeDir'),filename_i);
                    if ~isfile(filepathi)
                        isValidInclude=false;
                    end
                end
                
                if isValidInclude
                    nb=nb+1;
                    %             files(nb).fileInclude=fileInclude;
                    files(nb).filepath=filepathi;
                    %             files(nb).path=dirInput;
                end
            end
        end
        end
        
        
        function [isValidInclude,filename]=computeIsValidInclude_syntax(sourceCode,match,first,last);
        strError='parsing error';
        isValidInclude=false;
        filename='';
        
        match=match{1};%TODO:handle multiple includes
        first=first(1);
        last=last(1);
        
        stringBegin=sourceCode(1:first-1);
        isCommmented=dependency_funs.compute_isCommented(stringBegin);
        
        if isCommmented
            return;
        end
        
        stringAfter=sourceCode(first:end);
        % stringAfter=sourceCode(last+1:end);
        % [match, first, last] = regexp(stringAfter, '("(\S*)")|(<(\S*)>)', 'match', 'start', 'end');
        [match, first, last] = regexp(stringAfter, '("(\S*)")', 'match', 'start', 'end');
        if isempty(match)
            return;
        end
        match=match{1};
        match=match(2:end-1);
        
        isValidInclude=1;
        filename=match;
        0;
        end
        
        function isCommmented=compute_isCommented(string);
        isCommmented=false;
        %TODO:handle /*...*/ before #include statement
        % or upper in the file
        match = regexp(string, '(//)|(/\*)', 'match');
        if ~isempty(match)
            isCommmented=true;
        end
        end
        
        function isCompiled=compute_is_compiled(filepaths);
        if ischar(filepaths)
            filepaths={filepaths};
        end
        isCompiled=zeros(length(filepaths),1);
        for i=1:length(filepaths)
            isCompiled(i)=dependency_funs.compute_is_compiled_aux(filepaths{i});
        end
        end
        
        function isCompiled=compute_is_compiled_aux(filepath);
        filepath2=changeExt(filepath,['.',mexext()]);
        if ~isfile(filepath2)
            isCompiled=0;
            return;
        end
        t1=dir(filepath);
        t1=t1.datenum;
        t2=dir(filepath2);
        t2=t2.datenum;
        isCompiled=t2>=t1;
        isCompiled=t2>=t1;
        end
        
        function is_outdated=compute_is_mex_outdated_all(filepaths,mode);
        n=length(filepaths);
        is_outdated=zeros(n,1);
        for i=1:n
            is_outdated(i)=dependency_funs.compute_is_mex_outdated(filepaths{i},mode);
            dispProgress(i,n);
        end
        end
        
        function is_outdated=compute_is_mex_outdated(filepath,mode);
        if isempty(mode)
            mode='all';
        end
        if strcmp(mode,'all')
            is_outdated=1;
            return;
        end
        filepath_mex=changeExt(filepath,['.',mexext()]);
        if~isfile(filepath_mex)
            if strcmp(mode,'new')
                is_outdated=1;
            else
                is_outdated=0;
            end
            return;
        end
        
        files=dependency_funs.computeIncludeFiles(filepath);
        filepaths={files.filepath};
        % filepaths={files.fileInclude};
        filepaths{end+1}=filepath;
        t1=[];
        for i=1:length(filepaths)
            temp=dir(filepaths{i});
            t1(i,1)=temp.datenum;
        end
        
        temp=dir(filepath_mex);
        t2=temp.datenum;
        is_outdated=any(t2<=t1);
        0;
        end
        
        
    end
end