classdef eigs_funs
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

    methods(Static)
        function test
%         funs.eigs_optimized_bak1=@eigs_optimized_bak1;funs.eigs_compatible_with_eigs_optimized=@eigs_compatible_with_eigs_optimized;return;
%         funs=eigs_funs;
%         [result,timing]=funs.eigs_compatible_with_eigs_optimized(A,B,k,options,Afun1,Afun2,Afun3);
        
        end
        
        function [result,timing]=eigs_optimized_bak1(A,B,k,options,Afun1,Afun2,Afun3);
        [result,timing] = eigs_optimized(A,B,k,options,Afun1,Afun2,Afun3);
        end
        
        function [result,timing]=eigs_compatible_with_eigs_optimized(A,B,k,options,Afun1,Afun2,Afun3);
        sigma='LA';
        opts.issym=1;
        opts.disp=0;
        [X,lambda]=eigs(A,B,k,sigma,opts);
        lambda=diag(lambda);
        
        if strcmp(sigma,'LA')
            [val,indexesOrdered] = sort(lambda,'descend');
        elseif strcmp(sigma,'SA')
            [val,indexesOrdered] = sort(lambda,'ascend');
        else
            assert(0);
        end
        lambda = lambda(indexesOrdered);
        X = X(:,indexesOrdered);
        result.X=X;
        result.lambda=lambda;
        
        timing=[];
        
        % n                  :  length of matrix represented by A if A is a function
        % tol                :  default eps
        % p                  :  default min(max(2*k,20),n)
        % maxit              :  default max(300,ceil(2*n/max(p,1)))
        % v0                 :  default zeros(n,1)
        % cholB              :  [{0} | 1]
        % permB              :  default 1:n
        %
        % output :
        % result.X
        % result.lambda
        % result.flag
        % result.nbA_times_X
        % result.nbIterations
        % result.nbEigenvaluesConverged
        %
        % timing.preprocessing
        % timing.dsaupd
        % timing.A_times_X
        % timing.postprocessing
        % timing.total
        
        end
        
    end
end

