function files=find_files(dir_input,pattern,options);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

options='r'
options='d' directories
options='rd' recursive, directories
pattern: {'*.cpp','*.c'}
files=find_files('~/research/data/images/object_categories/3Ddataset/*/bla','*.jpg','r')
find_files('~/research/programs/autre_code/segmentation/segbench','bsdsRoot.m','r');
find_files('/Users/timothee/research/programs/graphcut','sandbox','rd');

TODO:uniformize sorting of files
find_text_files
getFiles
getFiles2
getDirs

B before a or after a? be consistent....


%}


% function files=getDirs_unix(dirInput);
% [a,b]=dos(['ls -d -1 ',dirInput]);
% [a,b]=dos(['ls -1 ',dirInput]);

if nargin<2
    pattern=[];
end
if nargin<3
    options=[];
end
option_string=compute_option_string(options);

dir_input=strrep(dir_input,' ','\ ');
if isempty(pattern)
    command=['find ',dir_input,option_string];
else
    if ~iscell(pattern)
        pattern={pattern};
    end
    string_pattern=' -name ';
    for i=1:length(pattern)
        string_pattern=[string_pattern,wrap_filename(pattern{i})];
        if i<length(pattern)
            string_pattern=[string_pattern,' -o -name '];
        end
    end
    string_pattern=[' \( ',string_pattern, ' \)'];
    command=['find ',dir_input,string_pattern,option_string];
end

[a,b]=dos(command);
if a==1
    files=compute_empty_files();
    return;
end
assert(a==0,'',b);

strings=string2strings(b);
strings=strings(1:end-1);

if isempty(strings)
    files=compute_empty_files();
    return;
end


for i=length(strings):-1:1
    stringi=strings{i};
    stringi=strrep(stringi,'//','/');%TODO:voir why occurs
    [path,name,ext]=mex_filepath_funs('fileparts',stringi);

    files(i).filepath=stringi;
    files(i).path=path;
    files(i).name=[name,ext];
    files(i).name0=name;
    files(i).ext=ext;
end

% [ignore,ind]=sort(lower({files.filepath}));
[ignore,ind]=sort({files.filepath});
files=files(ind);
files=files(:);

if nargout==0
    dispStrings2({files.filepath});
end
0;

function files=compute_empty_files();
files=emptyStruct({'filepath','path','name','ext'});

function option_string=compute_option_string(options);
% option_string=' -print';
option_string='';
is_rec=0;
is_file=1;
for i=1:length(options)
    switch options(i)
        case 'd'
            is_file=0;            
        case 'r'
            is_rec=1;
            
        otherwise
            assert(0);
    end
end

if is_file
    option_string=[option_string,' -type f'];
else
    option_string=[option_string,' -type d'];
end
if is_rec==0
    option_string=[option_string,' -prune'];
end

option_string=[option_string,' -print'];

0;

