classdef html_funs
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

    methods(Static)
        function scratch();
        end
        function test();
        end
        function string=hyperlink(path,line,str);
        path=expand_home(path);
        % path=file2file(path);
        
        % disp(['<a href="matlab: winopen(','''',path,'''','); ">',path,'</a>'])
        
        [path0,name,ext]=fileparts(path);
        if strcmp(path0,path)
            isDir=1;
        else
            isDir=0;
        end
        
        if nargin<3
            str=path;
        end
        
        if ~isDir
            if nargin>1
                link1=['<a href="matlab: opentoline(','''',path,''',str2num(''',num2str(line),''')); ">',str,'</a>'];
            else
                link1=['<a href="matlab: open2(','''',path,'''','); ">',str,'</a>'];
            end
            %     link1=['<a href="matlab: opentoline2(','''',path,''',''',num2str(line),'''); ">',path,'</a>'];
            link2=['<a href="matlab: open2(','''',path0,'''','); ">','dir','</a>'];
            string=[link1,';',link2];
        else
            string=['<a href="matlab: open2(','''',path,'''','); ">',str,'</a>'];
        end
        
        if nargout==0
            if usejava('desktop')
                disp(string);
            else
                disp([path,':',line,':',str]);
            end
        end
        end
        
        function string=colored_text_intervals(strings,labels);
        string=[];
        string=[string,'<HTML><BODY>'];
        %         colors={'#00FF00','#0000FF'};
        %         colors={'#000000','#0000FF'};
        colors={'black','#0000FF'};
        strings2=cell(length(strings),1);
        for i=1:length(strings)
            stringi=strings{i};
            stringi=strrep(stringi,sprintf('\n'),'<BR>');
            strings2{i}=['<font color=',colors{labels(i)},'>',stringi,'</font>'];
        end
        string=[string,cat(2,strings2{:})];
        string=[string,'</Body></HTML>'];
        end
        
        
        %         function opentoline2(path,numstring);
        %         opentoline2(path,str2num(numstring));
        %         end
        function string=compute_frames(filepaths);
        strings={};
        strings{end+1}='<html>';
        n=length(filepaths);
        stringi=repmat('1%,',1,n);
        stringi(end)=[];
        strings{end+1}=['<frameset cols="',stringi,'">'];
        for i=1:n
            strings{end+1}=['<frame src="',filepaths{i},'">'];
        end
        strings{end+1}=['</frameset'];
        string=strings2string(strings);
        end
    end
    
end



