//#include "main_for_mex_standalone.cpp"
//TODO:shouldn't compile this in compileDir
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

#ifdef IS_MEX_STANDALONE
#include <vector>
#include "MatlabInterface.cpp"

void mexFunction(int nargout, mxArray *out[], int nargin, const mxArray *in[]);

int main(int argc, char * const argv[]) {
    assert(argc==4||argc==2||argc==1);
    int i;
    const char*filepath_out=NULL;
    const char*filepath_in=NULL;
    int nargout=0;
    int nargin=0;
    
    if(argc>=4){
        assert(argc==4);
        filepath_out=argv[2];
        nargout=atoi(argv[3]);
    }
    
    vector<mxArray*>A_in;
    
    if(argc>=2){
        filepath_in=argv[1];
        MatlabInterface::getVariables(filepath_in, A_in);
        nargin=A_in.size();
    }
    
    vector<const mxArray*>A_in2(nargin);
    for(i=0;i<nargin;i++){
        A_in2[i]=const_cast<mxArray*>(A_in[i]);
    }
    vector<mxArray*>A_out(nargout);
    mexFunction(nargout, &A_out[0], nargin,&A_in2[0]);
    
    if(nargout>0){
        vector<string>names(nargout);
        for(i=0;i<nargout;i++){
            names[i]="A"+toStr(i+1);
        }
        MatlabInterface::putVariables(filepath_out, A_out, names);
        for(i=0;i<nargout;i++){
            mxDestroyArray(A_out[i]);
        }
    }
    for(i=0;i<nargin;i++){
        mxDestroyArray(A_in[i]);
    }
    return 0;
}
#endif
