/*
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

 * [path,name,ext]=mex_filepath_funs('fileparts',filepath);
 * [path,name,ext]=mex_filepath_funs('fileparts','/Users/timothee/research/programs/graphcut/include/Matrix.cpp')
 */
#include "Matrix.cpp"

class Class1{
public:
    void mexGate(int nargout, mxArray *out[], int nargin, const mxArray *in[]){
        char*s=mxArrayToString(in[0]);
        if(!strcmp(s, "fileparts")){
            mexGate_fileparts(nargout, out, nargin, in);
        }
        else
            assert(0);
    }
    void mexGate_fileparts(int nargout, mxArray *out[], int nargin, const mxArray *in[]){
        string filepath=mxArrayToString(in[1]);
        string path="";
        string name="";
        string ext="";
        
        size_t found=filepath.find_last_of("/\\");
        if(found==string::npos){
            
        }
        else{
            path=filepath.substr(0, found);
            string name_ext=filepath.substr(found+1);
            
            size_t found2=name_ext.find_last_of(".");
            if(found2!=string::npos){
                name=name_ext.substr(0, found2);
                ext=name_ext.substr(found2);
            }
            else{
                name=name_ext;
            }
        }
        
        out[0]=mxCreateString(path.c_str());
        out[1]=mxCreateString(name.c_str());
        out[2]=mxCreateString(ext.c_str());
    }
};

void mexFunction(int nargout, mxArray *out[], int nargin, const mxArray *in[]) {
    Class1 class1; class1.mexGate(nargout, out, nargin, in);
}
