function filepath=tempname2(ext0);
% in case doesn't work, /tmp is full in unix
%not guaranteed to return unique filepath in concurrent systems...
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

if nargin>=1
    isext=1;
else
    isext=0;
end

while 1
    filepath=tempname();
    if isext
        filepath=changeExt(filepath,ext0);
    end
    
    [ignore,name,ext]=fileparts(filepath);
    
    if ispc
    elseif ismac
        filepath=fullfile(getPaths('dir_temp'),[name,ext]);
    elseif isunix
        filepath=fullfile(getPaths('dir_temp'),[name,ext]);
    else
        assert(0);
    end
    
    if ~exist(filepath,'file')
        return;
    end    
end


