function strings=file2strings(file);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

strings = file2strings(which('file2strings.m'));
%}

assert(isfile(file));

[strings,isValid]=file2strings_textscan(file);
if ~isValid
    string=file2string(file);
    strings=string2strings(string);
end

% string = file2string(file);
% strings=string2strings(string);

% if verLessThen2('7.1')
%     strings0=file2strings_textscan(file);
%     isequal(strings0,strings)
% end

0;

function [strings,isValid]=file2strings_textscan(file);
fid = fopen(file);
% fid = fopen(file,'rt',);
% strings = textscan(fid, '%s', 'delimiter', '\n', 'whitespace', '');
try
    strings = textscan(fid, '%s', 'delimiter', '\n', 'whitespace', '');
catch
%     strings = textscan(fid, '%s', 'delimiter', '\n', 'whitespace', '','BufSize',4095*10000);%TODO:voir
    fclose(fid);
    isValid=0;
    strings=[];
    return;
end
isValid=1;
fclose(fid);

strings=strings{1};
if isempty(strings)
    strings={''};
    return;
end
fid = fopen(file);
fseek(fid, -1, 'eof');
string0 = fscanf(fid, '%c', 1);
fclose(fid);
if string0==sprintf('\n')
    strings{end+1,1}='';
end

%{
%TODO:try instead (much faster):
% strings = textread(file,'%s','delimiter','\n','whitespace','');
% strings = textread(file,'%s','delimiter','\n','whitespace','');
%}

%{
function strings=file2strings_fgets(file);
fid=fopen(file);
i=0;
while 1
    tline = fgets(fid);
    if ~ischar(tline), break, end
    i=i+1;
    strings{i,1}=tline;
    if length(tline)>=2 && tline(end-1)==sprintf('\r') && tline(end)==sprintf('\n')
        strings{i,1}=tline(1:end-2);
    elseif length(tline)>=1 && tline(end)==sprintf('\n')
        strings{i,1}=tline(1:end-1);
    end
%     strings{i,1}=tline(1:end);
%     strings{i,1}=[tline(1:end-2),sprintf('\n')];

% disp(i);

end
fclose(fid);
%}

