function message=mex2(filename,varargin);
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

[path,name,ext] = fileparts(filename);
if isempty(ext)
    filename=[filename,'.cpp'];
end

%mex2('mex_function.cpp','-argcheck'); %NO

% if nargin < 2
%     option = [];
% end
% if nargin < 3
%     option2 = [];
% end

% if exist(filename) == 2
%     filename2 = filename;
% else
%     filename2 = which(filename);
% end
filename2 = which(filename);
if strcmp(filename2,'')
    [path,name,ext] = fileparts(filename);
else
    [path,name,ext] = fileparts(filename2);
end
if strcmp(name,'') || strcmp(path,'')
    disp('file not found');
    return;
end


% if strcmp(filename2,'')
%     disp('file not found');
% end
% [path,name,ext] = fileparts(filename2);
if ~(strcmp(ext,'.cpp') ||  strcmp(ext,'.c') ||  strcmp(ext,'.cc'))
    ext = '.cpp';
end
message='';

try
    [errorCode,message]=mex_aux([name,ext],path,varargin{:});
catch
    errorCode=1;
end

if errorCode
    filepath='/Users/timothee/programs/gstlfilt/gSTLFilt.pl';
    if isfile(filepath)
        filepath_temp=tempfile();
        string2file(message,filepath_temp);
        [ignore,message]=dos(['perl ',filepath,' < ',filepath_temp]);
        delete(filepath_temp);
%         [ignore,message]=dos(['echo "',message,'" | ','perl ',filepath]); %doesn't always work, when there are backticks, etc 
    end
    if usejava('desktop')
        message=insert_click2view(message);
    end    
    
    disp(message);
    disp('ERROR using mex2');
else
    disp('SUCCESS');
end

function s=insert_click2view(s);
% [strings,s0]=regexp(s,'[^\: \n]+\:\d+\:','match','split');
[strings,s0]=regexp(s,'[^\: \n]+\:\d+','match','split');
s2{1}=s0{1};
for i=1:length(strings)
    stringi=strings{i};
    expr='(?<file>[^\: \n]+)\:(?<number>\d+)';
    token=regexp(stringi,expr,'names');    
    filepath=which(token.file);
    if isempty(filepath)
        stringi2=stringi;
    else
        stringi2=html_funs.hyperlink(filepath,token.number,stringi);
    end
    
    s2{i+1}=[stringi2,s0{i+1}];
end
s=cat(2,s2{:});
% cprintf(-[1,0,1], 'underlined magenta\n');
s=strrep(s,'error:','****ERROR****');
0;


